#include "Principal.h"


void destruirVetor(Aluno** vetorAlunos, int nAlunos)
{
    for(int i = 0; i < nAlunos; i++)
    {
        free(vetorAlunos[i]);
    }
}


void colherDadosAlunos(Aluno** vetorAlunos, int nAlunos)
{
    for(int i = 0; i < nAlunos; i++)
    {
        vetorAlunos[i] = (Aluno*) malloc(sizeof(Aluno));

        printf("Aluno %d\n", i+1);
        colherDados(vetorAlunos[i]);
    }
}


void calcularMedias(Aluno** vetorAlunos, int nAlunos)
{
    for(int i = 0; i < nAlunos; i++)
        calcularMedia(vetorAlunos[i]);
}


float calcularMediaGeral(Aluno** vetorAlunos, int nAlunos)
{
    float mediaGeral = 0;
    for(int i = 0; i < nAlunos; i++)
    {
        mediaGeral += vetorAlunos[i]->media;
    }
    mediaGeral /= nAlunos;

    return mediaGeral;
}


void informarMediaGeral(Aluno** vetorAlunos, int nAlunos)
{
    printf("A media geral da turma eh %.1f.\n", calcularMediaGeral(vetorAlunos, nAlunos));
}


void duasMaioresMedias(Aluno** vetorAlunos, int nAlunos)
{
    float maior = 0;
    float segundaMaior = 0;
    
    for(int i = 0; i < nAlunos; i++)
    {
        if(vetorAlunos[i]->media > maior)
        {
            segundaMaior = maior;
            maior = vetorAlunos[i]->media;
        }
        else if(vetorAlunos[i]->media > segundaMaior)
            segundaMaior = vetorAlunos[i]->media;
    }

    printf("As duas maiores medias sao %.1f e %.1f.\n", maior, segundaMaior);
}


int alunosAcimaDaMedia(Aluno** vetorAlunos, int nAlunos)
{
    float mediaGeral = calcularMediaGeral(vetorAlunos, nAlunos);
    int n = 0;

    for(int i = 0; i < nAlunos; i++)
    {
        if(vetorAlunos[i]->media > mediaGeral)
            n++;
    }

    return n;
}


void executar()
{
    int nAlunos = 30;
    Aluno* vetorAlunos[nAlunos];

    colherDadosAlunos(vetorAlunos, nAlunos);
    calcularMedias(vetorAlunos, nAlunos);
    informarMediaGeral(vetorAlunos, nAlunos);

    destruirVetor(vetorAlunos, nAlunos);
}
